import flask
from flask import jsonify, send_from_directory
import database

app = flask.Flask(__name__)
app.config["DEBUG"]=True


@app.route('/twitter-image-analysis/api/clusters', methods=['GET'])
def get_clusters():

    clusters = database.query('SELECT cluster FROM clusters GROUP BY cluster ORDER BY  cluster')
    cluster_output = []
    for c in clusters:
        cluster_output.append(c[0])
    return jsonify(cluster_output)


@app.route('/twitter-image-analysis/api/cluster/<string:cluster_id>/data', methods=['GET'])
def get_cluster_data(cluster_id):
    output = {}
    hashtag_output = []
    text_output = []
    hashtags = database.query('SELECT DISTINCT hashtag \
                                FROM clusters c JOIN media m ON (c.url_hash = m.url_hash) \
                                JOIN tweet t ON (m.tweet_id = t.id) \
                                LEFT JOIN hashtags ht ON (t.id = ht.tweet_id) \
                               WHERE hashtag IS NOT NULL  \
                                 AND cluster = ' + cluster_id + '')

    for c in hashtags:
        hashtag_output.append(c[0])

    texts = database.query('SELECT DISTINCT text \
                                FROM clusters c JOIN media m ON (c.url_hash = m.url_hash) \
                                JOIN tweet t ON (m.tweet_id = t.id) \
                                LEFT JOIN hashtags ht ON (t.id = ht.tweet_id) \
                               WHERE hashtag IS NOT NULL  \
                                 AND cluster = ' + cluster_id + '')

    for c in texts:
        text_output.append(c[0])
    output['texts'] = text_output
    output['hashtags'] = hashtag_output

    return jsonify(output)

@app.route('/twitter-image-analysis/api/cluster/<string:cluster_id>/image', methods=['GET'])
def get_cluster_image(cluster_id):
    return send_from_directory(directory='/Users/Vamsi/Downloads/ti/', filename='cluster-' + cluster_id + '.jpg')
 
app.run()