import psycopg2
from datetime import datetime
from datetime import timedelta
import time


query = """select concat(id, '^', created_at, '^', regexp_replace(text, '\r|\n', '', 'g'), '^', 
			  media_url,'^', hashtags,  '^', user_mentions, '^', userid) 
from (
select id, created_at, replace(text, '^', '') as text, userid, media_url, 
(select jsonb_agg(t -> 'text') from jsonb_array_elements(hashtags) as x(t)) as hashtags,
(select jsonb_agg(t -> 'id') from jsonb_array_elements(user_mentions) as x(t)) as user_mentions
from (
select id, created_at, text,userid , 
extended_entities -> 'extended_entities' -> 'media' -> 0 ->> 'media_url' as media_url,
entities -> 'entities' -> 'hashtags' as hashtags,
entities -> 'entities' -> 'user_mentions' as user_mentions
from twitterstatus ts 
where ts.created_at >= '{0}'
and ts.created_at < '{1}'
and lang = 'en '  limit {2})a
	)a
"""
conn = psycopg2.connect("host=10.128.6.136 dbname=postgres user=postgres")



def get_data(start_date, end_date, limit):
    cur = conn.cursor()
    outputquery = 'copy ({0}) to stdout '.format(query.format(str(start_date), str(end_date), limit))
    filename = str(start_date).replace(' ', '_').replace(':', '_')
    with open('/tmp/' + str(filename) + '.dat', 'w') as f:
        cur.copy_expert(outputquery, f)


start_date = datetime.strptime('2019-12-01', '%Y-%m-%d')
end_date = datetime.strptime('2019-12-03', '%Y-%m-%d')
delta = end_date - start_date

for d in range(delta.days):
    for m in range(4):
        sdate = start_date + timedelta(d) + timedelta(0.25 * m)
        edate = start_date + timedelta(d) + timedelta(0.25 * (m+1))
        start = time.time()
        get_data(sdate, edate, 1000000)
        print(str(sdate) + ' ---> ' + str(edate) + ' ---> ' + str(time.time() - start))

conn.close()
