#!/usr/bin/python
import psycopg2
import configparser

def generate(table):
    sql = "SELECT column_name, data_type " \
            "FROM information_schema.columns " \
            "WHERE table_name = '%s'" % table
    #print(sql)
    conn = None
    try:
        config = configparser.ConfigParser()
        config.read('config.ini')
        conn = psycopg2.connect(**config['postgres'])      
        cur = conn.cursor()        
        cur.execute(sql)
        row = cur.fetchone()
        columns = []
        types = []

        while row is not None:
            columns.append(row[0])
            types.append("%s")
            row = cur.fetchone()
        cur.close()
        insert_sql = "INSERT INTO {} ({}) VALUES({})" \
                        .format(table, ','.join(columns), ','.join(types))
        #print(insert_sql)
        return insert_sql
    except (Exception, psycopg2.DatabaseError) as error:
        print(error)
    finally:
        if conn is not None:
            conn.close()
    

def save(table, data):
    """ Connect to the PostgreSQL database server """
    conn = None
    try:
        config = configparser.ConfigParser()
        config.read('config.ini')
        conn = psycopg2.connect(**config['postgres'])      
        cur = conn.cursor()    
        sql = generate(table)    
        cur.executemany(sql,data)
        conn.commit()
        cur.close()
    except (Exception, psycopg2.DatabaseError) as error:
        print(error)
    finally:
        if conn is not None:
            conn.close()

def query(sql):
    conn = None
    try:
        config = configparser.ConfigParser()
        config.read('config.ini')
        print(config['postgres'])
        conn = psycopg2.connect(**config['postgres']) 
        cur = conn.cursor()
        cur.execute(sql)
        rows = cur.fetchall()
        cur.close()
        return rows
    except (Exception, psycopg2.DatabaseError) as error:
        print(error)
    finally:
        if conn is not None:
            conn.close()

#test 
if __name__ == '__main__':
    print(query("SELECT distinct url, url_hash FROM MEDIA"))
    