import collections
import configparser
import gensim
import itertools 
import matplotlib.pyplot as plt
import networkx as nx
import nltk
import numpy as np
import os
import pandas as pd
import pickle 
import psycopg2
import pyLDAvis
import re
import warnings
import seaborn as sns
import matplotlib
import random
import community
import networkx as nx
import time
import networkx.algorithms.community as nxcom
from matplotlib import pyplot as plt
from numpy import random as nprand
from itertools import combinations
from sklearn.model_selection import GridSearchCV
from sklearn.metrics.pairwise import cosine_similarity
from collections import OrderedDict
from gensim import corpora, models
from gensim.parsing.preprocessing import STOPWORDS
from gensim.summarization import mz_keywords
from gensim.utils import simple_preprocess
from mlxtend.preprocessing import TransactionEncoder
from nltk import bigrams
from nltk.corpus import stopwords
from nltk.sentiment.vader import SentimentIntensityAnalyzer
from nltk.stem import WordNetLemmatizer, SnowballStemmer
from nltk.stem.porter import *
from pandas import DataFrame
from pyLDAvis import sklearn as sklearn_lda
from sklearn.datasets import fetch_20newsgroups
from sklearn.decomposition import LatentDirichletAllocation as LDA
from sklearn.decomposition import NMF, LatentDirichletAllocation
from sklearn.decomposition import NMF, non_negative_factorization
from sklearn.feature_extraction.text import CountVectorizer
from sklearn.feature_extraction.text import TfidfVectorizer, CountVectorizer
from textblob import TextBlob
from time import sleep
import operator
from collections import defaultdict
warnings.filterwarnings("ignore")

def build_nmf(data):
    n_samples = 2000
    n_features = 1000
    n_components = 10 #Number of topics
    n_words = 20 #Number of top words to choose from each topic
    data_samples=data
    # Use tf-idf features for NMF.
    tfidf_vectorizer = TfidfVectorizer(max_df=0.95, min_df=2,
                                   max_features=n_features,
                                   stop_words=set(stopwords.words('english')))
    tfidf = tfidf_vectorizer.fit_transform(data_samples)
    nmf = NMF(n_components=n_components, random_state=1,
          beta_loss='kullback-leibler', solver='mu', max_iter=1000, alpha=.1,
          l1_ratio=.5).fit(tfidf)
    
    keywords = np.array(tfidf_vectorizer.get_feature_names())
    topic_keywords = []
    for topic_weights in nmf.components_:
        top_keyword_locs = (-topic_weights).argsort()[:n_words]
        topic_keywords.append(keywords.take(top_keyword_locs))
    df_topic_keywords = pd.DataFrame(topic_keywords)
    df_topic_keywords.columns = ['Word '+str(i) for i in range(df_topic_keywords.shape[1])]
    df_topic_keywords.index = ['Topic '+str(i) for i in range(df_topic_keywords.shape[0])]

    return tfidf_vectorizer,nmf,df_topic_keywords



def predict_topic(tfidf_vectorizer,nmf,df_topic_keywords,text):
    # Step 1: Vectorize transform
    #print(text)
    #print("\n\n")
    newtext = tfidf_vectorizer.transform(text)
    #print(newtext)
    #print("\n\n")
    # Step 2: NMF Transform
    topic_probability_scores = nmf.transform(newtext)
    topic_name = df_topic_keywords.iloc[np.argmax(topic_probability_scores), :].name
    topic = df_topic_keywords.iloc[np.argmax(topic_probability_scores), :].values.tolist()
    #print(topic_name, topic)
    #print("\n\n")
    return topic_name,topic


# start = time.time()
# conn = None
# sql="SELECT * from hashtags_agg order by uniq_users DESC"
# try:
#     config = configparser.ConfigParser()
#     config.read('config.ini')
#     conn = psycopg2.connect(**config['postgres']) 
#     cur = conn.cursor()
#     cur.execute(sql)
#     hashtags_agg = DataFrame(cur.fetchall())
#     cur.close()
# except (Exception, psycopg2.DatabaseError) as error:
#     print(error)
# finally:
#     if conn is not None:
#         conn.close()
# hashtags_agg.rename(columns={0:'hashtag',1:'uniq_users',2:'uniq_tweets',3:'ht_text'}, inplace=True)

# print(hashtags_agg.head())
# print("DB call took - " + str(time.time() - start))
# start = time.time()
# tfidf_vectorizer,nmf,df_topic_keywords=build_nmf(hashtags_agg['ht_text'])
# print("Build NMF took - " + str(time.time() - start))
# step1_df = hashtags_agg.copy()
# step1_df['topic_name'],step1_df['topic']  = step1_df['ht_text'].apply(lambda text: predict_topic(tfidf_vectorizer,nmf,df_topic_keywords,[text])).str
# print("Predict Topic took - " + str(time.time() - start))
# step1_df.to_pickle('hashtags_agg')


# start = time.time()
# conn = None
# sql="SELECT * from hashtag_cooccurence_w_media order by uniq_users DESC;"
# try:
#     config = configparser.ConfigParser()
#     config.read('config.ini')
#     conn = psycopg2.connect(**config['postgres']) 
#     cur = conn.cursor()
#     cur.execute(sql)
#     hashtag_cooc_w_media = DataFrame(cur.fetchall())
#     cur.close()
# except (Exception, psycopg2.DatabaseError) as error:
#     print(error)
# finally:
#     if conn is not None:
#         conn.close()
# hashtag_cooc_w_media.rename(columns={0:'ht1',1:'ht2',2:'uniq_users', 3:'uniq_tweets', 4:'ht_text'}, inplace=True)
# print("DB call took - " + str(time.time() - start))
# start = time.time()
# tfidf_vectorizer,nmf,df_topic_keywords=build_nmf(hashtag_cooc_w_media['ht_text'])
# print("Build NMF took - " + str(time.time() - start))
# start = time.time()

# step2_df = hashtag_cooc_w_media.copy()
# print(step2_df.shape)
# step2_df['topic_name'],step2_df['topic'] = step2_df['ht_text'].apply(lambda text: predict_topic(tfidf_vectorizer,nmf,df_topic_keywords,[text])).str


# step2_df.to_pickle('hashtag_cooc_w_media')



# hashtag_cooc_wo_media

start = time.time()
conn = None
sql="SELECT * from hashtag_cooccurence_wo_media order by uniq_users DESC;"
try:
    config = configparser.ConfigParser()
    config.read('config.ini')
    conn = psycopg2.connect(**config['postgres']) 
    cur = conn.cursor()
    cur.execute(sql)
    hashtag_cooc_wo_media = DataFrame(cur.fetchall())
    cur.close()
except (Exception, psycopg2.DatabaseError) as error:
    print(error)
finally:
    if conn is not None:
        conn.close()
hashtag_cooc_wo_media.rename(columns={0:'ht1',1:'ht2',2:'uniq_users', 3:'uniq_tweets', 4:'ht_text'}, inplace=True)

print("DB call took - " + str(time.time() - start))
tfidf_vectorizer,nmf,df_topic_keywords=build_nmf(hashtag_cooc_wo_media['ht_text'])
hashtag_cooc_wo_media.head()
print("Build NMF took - " + str(time.time() - start))
step3_df = hashtag_cooc_wo_media.copy()
step3_df['topic_name'],step3_df['topic']  = step3_df['ht_text'].apply(lambda text: predict_topic(tfidf_vectorizer,nmf,df_topic_keywords,[text])).str
print("Predict Topic took - " + str(time.time() - start))
step3_df.to_pickle('hashtag_cooc_wo_media')