
    var hashtag_filter;

    
    var edgeTopicsFiltered = new Set();
    var filtered_hashtags = [];

    topic_names_local = new Map();

    file_paths['Hashtag co-occurrence'] ='data/hashtag_cooc_w_media.json';
  
       
    /**
     * DOM utility functions
     */
    var _ = {
      $: function (id) {
        return document.getElementById(id);
      },

      all: function (selectors) {
        return document.querySelectorAll(selectors);
      },

      removeClass: function (selectors, cssClass) {
        var nodes = document.querySelectorAll(selectors);
        var l = nodes.length;
        for (i = 0; i < l; i++) {
          var el = nodes[i];
          // Bootstrap compatibility
          el.className = el.className.replace(cssClass, '');
        }
      },

      addClass: function (selectors, cssClass) {
        var nodes = document.querySelectorAll(selectors);
        var l = nodes.length;
        for (i = 0; i < l; i++) {
          var el = nodes[i];
          // Bootstrap compatibility
          if (-1 == el.className.indexOf(cssClass)) {
            el.className += ' ' + cssClass;
          }
        }
      },

      show: function (selectors) {
        this.removeClass(selectors, 'hidden');
      },

      hide: function (selectors) {
        this.addClass(selectors, 'hidden');
      },

      toggle: function (selectors, cssClass) {
        var cssClass = cssClass || "hidden";
        var nodes = document.querySelectorAll(selectors);
        var l = nodes.length;
        for (i = 0; i < l; i++) {
          var el = nodes[i];
          //el.style.display = (el.style.display != 'none' ? 'none' : '' );
          // Bootstrap compatibility
          if (-1 !== el.className.indexOf(cssClass)) {
            el.className = el.className.replace(cssClass, '');
          } else {
            el.className += ' ' + cssClass;
          }
        }
      }
    };


    function update_dataset_hashtag() {

        current_data_file_name = $('#select-dataset-value').val();
        $("#graph_title").html(current_data_file_name);

        console.log(current_data_file_name);
        current_data_file_path = file_paths[current_data_file_name]
        console.log(current_data_file_path)

        createNewGraph_hashtags();

    
    
    }

    function updatePane_hashtags(graph, hashtag_filter) {
      // get max degree
      var maxDegree = 0,
        node_topic_categories = {};
        edge_topic_categories = {};
        edge_media_categories = {};
        edge_without_media_categories = {};


      // local_nodes = graph.nodes();
      // for (i = 0; i < 100; i++)
      //   graph.edges().push({
      //     id: 'e' + i,
      //     label: 'Edge ' + i,
      //     source: local_nodes[getRandomInt(local_nodes.length)].source,
      //     target: local_nodes[getRandomInt(local_nodes.length)].target,
      //     // size: Math.random(),
      //     size: 10000,
      //     color: '#ccc',
      //     count: i,
      //     type: ['line', 'curve', 'arrow', 'curvedArrow'][Math.random() * 4 | 0]
      //   });


      $("#topic_number").hide();
      $("#topic_names").hide();
      //$("#select-hashtag-count").show();
      // read nodes
      graph.nodes().forEach(function (n) {
        maxDegree = Math.max(maxDegree, graph.degree(n.id));
        node_topic_categories[n.topic_name] = true;

        topic_names_local[n.topic_name] =n.topic;

        var option_str = '<option value="'+n.hashtag+'">'+n.hashtag+'</option>';
        $("#select-hashtag-count").append(option_str);
      })

      $("#select-hashtag-count").trigger("chosen:updated");

      // read edges
      graph.edges().forEach(function (e) {
        // maxDegree = Math.max(maxDegree, graph.degree(n.id));
        e.color = topic_colors[e.topic_name];
        edge_topic_categories[e.topic_name] = true;
        // count == 0 => with media 
        if(e.count == 0){
          edge_media_categories[e.topic_name] = true;
          e.type =  'curvedArrow';
        }else{
          edge_without_media_categories[e.topic_name] = true;
          e.type =  'curve';
        }
        
        
        // e.count = e.id;

      })


      // min degree
      _.$('min-degree').max = maxDegree;
      _.$('max-degree-value').textContent = maxDegree;

      // node category
      
      $('#hashtag-node-category').empty();
      var nodecategoryElt = _.$('hashtag-node-category');
      var optionElt = document.createElement("option");
      optionElt.text = "All Topics";
      nodecategoryElt.add(optionElt);
      Object.keys(node_topic_categories).forEach(function (c) {
          var optionElt = document.createElement("option");
          optionElt.text = c;
          optionElt.style.color = topic_colors[optionElt.text];
          nodecategoryElt.add(optionElt);
      });

      // edge category
      $('#hashtag-edge-category').empty();
      var edgecategoryElt = _.$('hashtag-edge-category');
      var optionElt = document.createElement("option");
      optionElt.text = "All Topics";
      edgecategoryElt.add(optionElt);
      var optionElt = document.createElement("option");
      Object.keys(edge_topic_categories).forEach(function (c) {
          var optionElt = document.createElement("option");
          optionElt.text = c;
          optionElt.style.color = topic_colors[optionElt.text];
          edgecategoryElt.add(optionElt);
      
      });

      // Media category
      $('#hashtag-media-category').empty();
      var edgecategoryElt = _.$('hashtag-media-category');
      
      if (edge_media_categories != {} ){
        var optionElt = document.createElement("option");
        optionElt.text = "With Media";
        edgecategoryElt.add(optionElt);
      }
      if (edge_without_media_categories != {}){
        var optionElt = document.createElement("option");
        optionElt.text = "Without Media";
        edgecategoryElt.add(optionElt);
      }
      if (edge_media_categories != {} && edge_without_media_categories != {} ){
        var optionElt = document.createElement("option");
        optionElt.text = "Both";
        edgecategoryElt.add(optionElt);
      }

 
    
      // reset button
      _.$('reset-btn').addEventListener("click", function (e) {
        _.$('min-degree').value = 0;

        _.$('hashtag-node-category').selectedIndex = 0;
        _.$('hashtag-edge-category').selectedIndex = 0;
        _.$('hashtag-media-category').selectedIndex = 0;

        topics_to_show = new Set();
        hashtag_filter.undo().apply();
      });


    }

    // these are just some preliminary settings 
    var g = {
      nodes: [],
      edges: []
    };

    // Create new Sigma instance in graph-container div (use your div name here) 
    s = new sigma({
      graph: g,
      container: 'graph-container',
      renderer: {
        container: document.getElementById('graph-container'),
        type: 'canvas',
        // type: 'svg',
        freeStyle: true
      },
      settings: {
        edgeColor: 'default',
        defaultEdgeColor: '#ccc',
        minNodeSize: 8,
        maxEdgeSize: 5, // think if this as edge size mod 
        enableEdgeHovering: true,
        edgeHoverColor: 'edge',
        defaultEdgeHoverColor: '#000',
        edgeHoverSizeRatio: 1.5,
        edgeHoverExtremities: true,
        doubleClickEnabled: true,
        edgeLabelSize: '100'
      }
    });

 
    // s.bind('overNode outNode clickNode doubleClickNode rightClickNode', function(e) {
    //   console.log(e.type, e.data.node.label, e.data.captor);
    // });
    // s.bind('overEdge outEdge clickEdge doubleClickEdge rightClickEdge', function(e) {
    //   console.log(e.type, e.data.edge, e.data.captor);
    // });
    // s.bind('clickStage', function(e) {
    //   console.log(e.type, e.data.captor);
    // });
    // s.bind('doubleClickStage rightClickStage', function(e) {
    //   console.log(e.type, e.data.captor);
    // });

    // first you load a json with (important!) s parameter to refer to the sigma instance   
    // sigma.parsers.json('data/mentions.json',
    
    function createNewGraph_hashtags()
    {
    sigma.parsers.json(current_data_file_path,

      s,
      function () {

        // this below adds x, y attributes of node
        nodes = s.graph.nodes(),
        
        len = nodes.length;
        console.log("node size:" + len);

        for (i = 0; i < len; i++) {
          nodes[i].x = Math.random();
          nodes[i].y = Math.random();
          // nodes[i].size = s.graph.degree(nodes[i].id);
          nodes[i].color = topic_colors[nodes[i].topic_name]
        }

        //edge mod
        // edges = s.graph.nodes(),
        // len = edges.length;
        // console.log("edge size:" + len);

        // for (i = 0; i < len; i++) {
        //   // nodes[i].size = s.graph.degree(nodes[i].id);
        //   edges[i].type ='curvedArrow';
        //   edges[i].color = topic_colors[edges[i].topic_name]
        //   edges[i].label = "Amir"
        // }


        // filters
        hashtag_filter = new sigma.plugins.filter(s);
        updatePane_hashtags(s.graph, hashtag_filter);

        function applyMinDegreeFilter(e) {
          var v = e.target.value;
          _.$('min-degree-val').textContent = v;

          hashtag_filter
            .undo('min-degree')
            .nodesBy(function (n) {
              return this.degree(n.id) >= v;
            }, 'min-degree')
            .apply();
        }

        // -------------------------------------------------------------------------------------
        function applyCategoryFilterNodes(e) {

          
          topics_to_show = new Set();

          var c;
          if(e != null) {
            c = e.target[e.target.selectedIndex].value;
          }          
  
              
     

          if (c === 'All Topics') {
            filter
              .undo('node-category')
              .apply();

          } else {
            hashtag_filter
              .undo('node-category')
              .nodesBy(function (n) {

                if( filtered_hashtags.length != 0 && filtered_hashtags.includes(n.hashtag)){
                  topics_to_show.add(n.topic_name)
                }          
      

                if ( c!= null){

                  topics_to_show.add(n.topic_name)
                  return !c.length || n.topic_name === c;
                
                } else if (c == null) {

                  return filtered_hashtags.includes(n.hashtag);

                } else if ( filtered_hashtags.length != 0 && c!= null) {
                  return filtered_hashtags.includes(n.hashtag) && n.topic_name === c ;
                }

              }, 'node-category')
              .apply();
            
              hashtag_filter.
              edgesBy(function (e) {
                edgeTopicsFiltered.add(e.topic_name);
                topics_to_show.add(e.topic_name)
                return e;
              });
              
          }

          
          console.log(topics_to_show);

          



                    // topic = 
         // $("#topic_number").html('Topic Name : ' + topics_to_show);

         $("#topic_names").show();
          var topic_details = "";
          if (topics_to_show.length  != 0) {

            topics_to_show.forEach(function (item, index) {
              topic_details +=  item + '<p style="color:' + topic_colors[item] + '";>'  +  topic_names_local[item] + '</p>' ;
              console.log(topic_details);
            });

            $("#topic_names").html(topic_details);
          }
          // var topic_num = topic.replace('Topic ', '');
          
          



           // edge category ( sub filter)
           $('#hashtag-edge-category').empty();
           var edgecategoryElt = _.$('hashtag-edge-category');
           var optionElt = document.createElement("option");
           optionElt.text = "All Topics";
           edgecategoryElt.add(optionElt);
           var optionElt = document.createElement("option");
           

           edgeTopicsFiltered.forEach( element => {
             if (edgecategoryElt) {
               var optionElt = document.createElement("option");
               optionElt.text = element;
               optionElt.style.color = topic_colors[optionElt.text];
               edgecategoryElt.add(optionElt);
             }  
           }
           );

        }


        function applyCategoryFilterEdges(e) {
          var c = e.target[e.target.selectedIndex].value;
          if (c === 'All Topics') {
            hashtag_filter
            .undo('edge-category')
            .apply();

          } else {
            hashtag_filter
            .undo('edge-category')
            .edgesBy(function (n) {
              
              return !c.length || n.topic_name === c;
            }, 'edge-category')
            .apply();
          }
        }

        function applyCategoryFilterMediaEdges(e) {

          var c = e.target[e.target.selectedIndex].value;
          if (c === 'Both') {
            hashtag_filter
              .undo('edge-media-category')
              .apply();

          } else if (c === "With Media") {

            hashtag_filter
              .undo('edge-media-category')
              .edgesBy(function (n) {


                return !c.length || n.count === 0;

              }, 'edge-media-category')
              .apply();
          } else if (c === "Without Media") {

            hashtag_filter
              .undo('edge-media-category')
              .edgesBy(function (n) {

                return !c.length || n.count === 1;

              }, 'edge-media-category')
              .apply();
          }
        }


        _.$('min-degree').addEventListener("input", applyMinDegreeFilter);  // for Chrome and FF
        _.$('min-degree').addEventListener("change", applyMinDegreeFilter); // for IE10+, that sucks
        _.$('hashtag-node-category').addEventListener("change", applyCategoryFilterNodes);
        _.$('hashtag-edge-category').addEventListener("change", applyCategoryFilterEdges);
        _.$('hashtag-media-category').addEventListener("change", applyCategoryFilterMediaEdges);

        

        $("#select-hashtag-count").change(function () {

          filtered_hashtags = [];
          $("#select-hashtag-count option:selected").each(function () {

            filtered_hashtags.push($(this).text())
            
          });
          applyCategoryFilterNodes();
          
        });


   
        

       

        // end filters

        // Refresh the display:
        s.refresh();

        // ForceAtlas Layout
        //s.startForceAtlas2();


        // mute
        // s.addRenderer({
        //   id: 'main',
        //   type: 'svg',
        //   container: document.getElementById('graph-container'),
        //   freeStyle: true
        // });
    
        
        function mute(node) {
          if (!~node.getAttribute('class').search(/muted/))
            node.setAttributeNS(null, 'class', node.getAttribute('class') + ' muted');
        }
        
        function unmute(node) {
          node.setAttributeNS(null, 'class', node.getAttribute('class').replace(/(\s|^)muted(\s|$)/g, '$2'));
        }
        
        $('.sigma-node').click(function() {
        
          // Muting
          $('.sigma-node, .sigma-edge').each(function() {
            mute(this);
          });
        
          // Unmuting neighbors
          var neighbors = s.graph.neighborhood($(this).attr('data-node-id'));
          neighbors.nodes.forEach(function(node) {
            unmute($('[data-node-id="' + node.id + '"]')[0]);
          });
        
          neighbors.edges.forEach(function(edge) {
            unmute($('[data-edge-id="' + edge.id + '"]')[0]);
          });
        });
        
        s.bind('clickStage', function() {
          $('.sigma-node, .sigma-edge').each(function() {
            unmute(this);
          });
        });


        // endmute


      }
    );

      // Refresh the display:
      s.refresh();

    }

    createNewGraph_hashtags();

    var dragListener = sigma.plugins.dragNodes(s, s.renderers[0]);


    

    // Configure the noverlap layout:
    var noverlapListener = s.configNoverlap({
      nodeMargin: 0.1,
      scaleNodes: 1.05,
      gridSize: 75,
      easing: 'quadraticInOut', // animation transition function
      duration: 10   // animation duration. Long here for the purposes of this example only
    });
    // Bind the events:
    noverlapListener.bind('start stop interpolate', function (e) {
      console.log(e.type);
      if (e.type === 'start') {
        console.time('noverlap');
      }
      if (e.type === 'interpolate') {
        console.timeEnd('noverlap');
      }
    });
    // Start the layout:
    s.startNoverlap();

    
